
bind Bulle <Enter> {
  catch {
    set Bulle(set) 0
    set Bulle(first) 1
    set Bulle(id) [after 500 {balloon %W $Bulle(%W) %X %Y}]
  }
}

bind Bulle <Button> {
  catch {
    set Bulle(first) 0
    kill_balloon
  }
}

bind Bulle <Leave> {
  catch {
    set Bulle(first) 0
    kill_balloon
  }
}

bind Bulle <Motion> {
   catch {
    if {$Bulle(set) == 0} {
        after cancel $Bulle(id)
        set Bulle(id) [after 500 {balloon %W $Bulle(%W) %X %Y}]
    }
   }
}

proc set_balloon {target message} {
    global Bulle
    catch {
      set Bulle($target) $message
      bindtags $target "[bindtags $target] Bulle"
    }
}

proc kill_balloon {} {
    global Bulle
    catch {
       if {[catch {after cancel $Bulle(id)}]} return
       if {[winfo exists .balloon] == 1} {
          destroy .balloon
       }
       set Bulle(set) 0
    }
}

proc balloon {target message {cx 0} {cy 0} } {
  global Bulle
  catch {
    if {$Bulle(first) == 1 } {
        set Bulle(first) 2
	if { $cx == 0 && $cy == 0 } {
	    set x [expr [winfo rootx $target] + ([winfo width $target]/2)]
	    set y [expr [winfo rooty $target] + [winfo height $target] + 4]
	} else {
	    set x [expr $cx + 4]
	    set y [expr $cy + 4]
	}
        catch {
         toplevel .balloon -bg black -screen [winfo screen $target]
         wm overrideredirect .balloon 1
         label .balloon.l \
             -text $message -relief flat \
             -bg #ffffd7 -fg black -padx 2 -pady 0 -anchor w
         pack .balloon.l -side left -padx 1 -pady 1
         wm geometry .balloon +${x}+${y}
         set Bulle(set) 1
        }
    }
  }
}

