

proc answerCTCP { nick tipo stringa id } {
 global me 
 puts $me($id,sock) "NOTICE $nick :\001$tipo $stringa\001"
}

proc displayCTCP { nick userid host tipo id chan } {
 global active act colsTXT icons wid
 if {$act(ctcp)} {
   set win $active($id)
 } else {
   set win status
 }
 set ctcp "CTCP"
 if {$chan!=""} {
   set win [GetWindow $chan $id]
   if {!([info exists wid($win,text)]&&$win!=""&&[winfo exists $wid($win,text)])} {return}
   set ctcp "CHANNEL $ctcp"
   IfColorButton $win $id
 }
 if {$icons(show)} {
     ImageText $win ctcp
 }
 # put in the double $userid@$host, to see if i can get rid of a bug. 5.15.04
 NormalText $win [AddressText [format [mc "%s %s request from %s %s"] $ctcp $tipo $nick "\[$userid@$host\]"] "\[$userid@$host\]" ""] $colsTXT(ctcp) 1
 #NormalText $win [format [mc "%s %s request from %s %s"] $ctcp $tipo $nick "\[$userid@$host\]"] $colsTXT(ctcp) 1
}

proc workoutCTCP { buffer len_buff id} {
 global me clientMSG colsTXT
 set chan ""
 	
	if {[lindex [Convert $buffer] 2]!=[Convert [::savirc::getNick $id]]} {
    		set chan [lindex [Convert $buffer] 2]
 	}

 set nick [get_nick $buffer]
 set userid [get_userid $buffer]
 set host [get_host $buffer]
 set type [Reverse [string toupper [lindex [Convert $buffer] 3]]]
 set type2 [Reverse [string toupper [lindex [Convert $buffer] 4]]]
 set tipo [string trim [string range $type 1 end] "\001"]
 set txt [join [lrange [Convert $buffer] 4 end]]
 set len [string length $type]
 set type [string range $type 1 $len]
 
 if {$type=="\001VERSION\001"} {
  		if {[Ignore $buffer c]} {return}
  
  		answerCTCP $nick VERSION $me(version) $id
  		set host [get_host $buffer]
  		set tipo "VERSION"
  		displayCTCP $nick $userid $host VERSION $id $chan
 
 	} elseif {$type=="\001TIME\001"} {
  		if {[Ignore $buffer c]} {return}
  		
		set tempo [clock format [clock seconds]]
  		answerCTCP $nick TIME $tempo $id
  		displayCTCP $nick $userid $host TIME $id $chan
  		set tipo "TIME"
 
 	} elseif {$type=="\001PING"} {
  		if {[Ignore $buffer c]} {return}
  
  		displayCTCP $nick $userid $host PING $id $chan
  		set when [Reverse [string trim [Convert [lindex $buffer 4]] "\001"]]
  		answerCTCP $nick PING $when $id 
  		set tipo "PING"
 
 	}  elseif {$type=="\001USERINFO\001"} {
  		if {[Ignore $buffer c]} {return}
  
  		displayCTCP $nick $userid $host USERINFO $id $chan
  		answerCTCP $nick USERINFO $clientMSG(userinfo) $id
  		set tipo "USERINFO"
 
 	}  elseif {$type=="\001CLIENTINFO\001"} {
  		if {[Ignore $buffer c]} {return}
  
  		set tipo "CLIENTINFO"
  		displayCTCP $nick $userid $host CLIENTINFO $id $chan
  		answerCTCP $nick CLIENTINFO "CLIENTINFO TIME PING USERINFO VERSION" $id

 	}  elseif {$type=="\001DCC" && [string first "SEND" $type2]!=-1} {
    		if {[Ignore $buffer d]} {return}
    		
		SendRequest $buffer $id
    		return
 
 	}  elseif {$type=="\001DCC" && [string first "CHAT" $type2]!=-1} {
    		if {[Ignore $buffer d]} {return}
    
    		ChatRequest $buffer $id
    		return
 
 	}  elseif {$type=="\001DCC" && [string first "RESUME" $type2]!=-1} {
    		if {[Ignore $buffer d]} {return}
    
    		DCCResume $buffer $id
   		return
  
  	}  elseif {$type=="\001DCC" && [string first "ACCEPT" $type2]!=-1} {
		if {[Ignore $buffer d]} {return}
    
    		DCCResumeGet $id $buffer
    		return
 }

 IRC::Event000 ctcp $me($id,net) id $id nick $nick user $userid host $host type $tipo txt $txt
}

proc showCTCP { id buffer len_buff } {
  global ctcpcolor active act
  set nick [get_nick $buffer]
  set host [get_host $buffer]
  set userid [get_userid $buffer]
  set type [lindex $buffer 3]
  set type [string range $type 2 end]
  set len [string length $type]
  set iniz [string first " :" $buffer]
  set msg [string range $buffer [expr $iniz+$len+4] [expr $len_buff-2]]
  activeCTCP $id $type $nick $userid $host $msg
}




proc activeCTCP { id tipo nick user host text } {
 global active act colsTXT ping icons me
    if {$act(ctcp)} {
      set win $active($id)
    } else {
      set win status
    }
    if {$tipo=="PING"} {
       if {[catch {set oldtime $ping($nick)} r]} {
        return
       }
       set current [clock seconds]
       set timegap [expr $current-$oldtime]
       set text "$timegap seconds"
       array unset ping $nick
    }

    if {$icons(show)} {
       ImageText $win ctcp
    }
    NormalText $win [AddressText [format [mc "CTCP %s reply from %s %s"] $tipo $nick "\[$user@$host\]"] " : " $text] $colsTXT(ctcp) 1
    IRC::Event000 ctcpreply $me($id,net) id $id nick $nick user $user host $host type $tipo reply $text
}

