
proc Identd_Create {} {
   global me
   if {!$me(ident_active)} {
     if {[catch {socket -server Ident_Connect $me(ident_port)} me(ident)]} { 
       IRC::echo [format [mc "Cannot start identd server: %s"] $me(ident)]
       return
     }
     set me(ident_active) 1
   } else {
     if {[catch {close $me(ident)} e]} { 
       IRC::echo [mc "Error shutting down Identd: %s"] $e]
       return
     }
     set me(ident_active) 0
   }
}

proc Ident_Connect { x y z } { 
    
    fileevent $x readable "Identd $x $y $z" 
    fconfigure $x -buffering line -blocking 1 
}

proc Identd { x y z } { 
    global me 
    gets $x blah
    regsub -all { } $blah {} data
    if {$me(ident_show)} {IRC::echo [format [mc "Ident Request From %s"] $y]}
    set data "[split $data ,]"
    if {([llength $data] == 2) && ([lindex $data 0] < 65535) && ([lindex $data 1] < 65535) && ([string trim $data 1234567890] == " ")} {
            set reply "[join [lrange $blah 0 2]] : USERID : $me(ident_system) : $me(userid)"
            if {![catch {puts $x "$reply"}]} { 
               if {$me(ident_show)} {IRC::echo [format [mc "Ident Request Replied: %s"] $reply]}
            }
    } else { 
       if {$me(ident_show)} {IRC::echo [format [mc "Invalid Ident Request Received From %s"] $y]}
    }

    if {$me(ident_use)&&$me(ident_active)&&$me(ident_connect)} {
         Identd_Create             
    }

    catch {flush $x}
    catch {close $x}
}



